# PF4

## About
This is an exploration of the [PatternFly](https://www.patternfly.org/v4/) design system in [`elm-ui`](https://package.elm-lang.org/packages/mdgriffith/elm-ui/latest/).

## PatternFly Components

_Built with `elm-ui` and the Builder Pattern_.

### Installation

```
elm install lenards/elm-ui-patternfly
```

:memo: - thanks for you interest; please note this is a package in _**early**_ developement.

### Status

This is a singular effort without official support. Though the version of this package is >1.0.0, this is a _very "alpha"_ offering at this time. Your patience & interest are appreciated. If you have ideas, feedback, or overall comments, please consider filing [_an issue_](./issues)

Documentation is in a _nascent_ and incomplete form - my advance & abject apologies.

### Materials

As the exploration "sets out", the following materials have been "of use."

Thank you to their creators :bow:

Links:
  - https://www.patternfly.org/v4/components/
  - https://github.com/dwyl/learn-elm/issues/141
    - https://youtu.be/PDyWP-0H4Zo
  - https://www.elm.christmas/2020/18
    - _(thanks to Bekk for this series)_
  - http://sporto.github.io/elm-patterns/advanced/pipeline-builder.html

Book(s):
  - https://korban.net/elm/elm-ui-guide/
    - Patterns: https://korban.net/elm/elm-ui-patterns/
    - Related: https://korban.net/elm/catalog/packages/ui/elm-ui

Bonus:
  - https://dev.to/lucamug/elm-beginners-tutorial-how-to-make-animated-snackbars-with-zero-css-12g1
  - https://korban.net/posts/elm/2020-04-07-using-elm-animator-with-elm-ui/

## Developing

Guidance on contributing will be forthcoming by mid-September 2021. It will be heavily inspired by the [`CONTRIBUTING.md`](https://github.com/ianmackenzie/elm-geometry/blob/master/CONTRIBUTING.md) provided in Ian Mackenzie's `elm-geometry` package.

## Examples

Given how _far down_ in the README this appears - I hope you might understand that the "Examples" are not in a particularly "robust" form at this time.

This repository recently shifted from being a _"kicking the trees"_ endeavor to an actual package (or library). In doing that, I'm trying to find ways of demonstrating the PF4 components in a way to see if they're usage, helpful, and fit their intended purpose. It's in the middle of becoming a library with an Elm Book sample application.


There is a "lofi" example that will morph into "A PF4 Guide in PF4" (or, a PF4 implementation design guide on the PF4 components) and the beginnings of an [ElmBook](https://github.com/dtwrks/elm-book). Of the two examples, the ElmBook one has the least effort invested at the moment.

Each example started as [Create Elm App](https://github.com/halfzebra/create-elm-app). Though they are (currently) `elm reactor` compatible, I am developing them using `elm-app` commands. As PF4 components are more _"flesh out"_, there will be [Ellie](https://ellie-app.com/) examples since I think that's is likely a better manner for getting feedback about them.


You can find the default information provided by `Create Elm App` in the [**Examples**](./examples/README.md) below.

